/*=============================================================================
#
#   Author: 		dantezhu - zny2008@gmail.com
#
#   QQ : 			327775604
#
#   Last modified:	2009-11-05 19:30
#
#   Filename:		forkwork_use.cpp
#
#   Description:	̵һܣҿֱʹãѾܲԺѹԡ
#					룺g++ forkwork_use.cpp -o forkwork_use (ʵϿд VIM-һ뵥Դļ ĻֱӰF5)
#
=============================================================================*/
#include <iostream>
#include <pthread.h>
#include <asm/atomic.h>
#include <string>
#include <vector>
#include <sys/time.h>
#include <asm/atomic.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <map>

using namespace std;
//=============================================================================
typedef std::pair<pid_t,int> pidPair;
map<pid_t,int> g_MapPids;



int DoYourWork(int iIndex);
/** 
 * @brief	ӽҪĶ
 * 
 * @param	bNeedCon			true̷ӽͻӽ̣falseӽ̶˳֮Ҳ˳
 * 
 * @return	0					succ
 * 			else 				fail
 */
int DetectPids(bool bNeedCon)
{
	pid_t pid;
	pid_t _n_pid;
	int Ret;

	for(;;)
	{
		//ȴӽ˳
		pid = waitpid(-1,NULL,0);
		if ( pid < 0 )
		{
			sleep(1);
			continue;
		}
		if(!bNeedCon)//ȴ
		{
			g_MapPids.erase(pid);
			if(g_MapPids.size()==0)
				return 0;
		}
		else//
		{
			if(g_MapPids.count(pid)<=0)
			{
				sleep(1);
				continue;
			}
			int index=g_MapPids.find(pid)->second;
			g_MapPids.erase(pid);

			_n_pid = fork();
			if(_n_pid<0)
			{
				sleep(1);
				continue;
			}
			else if ( _n_pid == 0 )
			{
			      printf("i am child\n");
				g_MapPids.clear();
				Ret = DoYourWork(index);	
				return Ret;
			}
			else
			{
			      	printf("i am farther,child is %d,index is %d\n",_n_pid,index);
				g_MapPids.insert(pidPair(_n_pid,index));
			}
			sleep(1);
		}
	}
	return 0;
}

/** 
 * @brief	ִӽ̵߼ҪĶ
 * 
 * @param	forknum			ӽ̸
 * @param	bNeedCon			true̷ӽͻӽ̣falseӽ̶˳֮Ҳ˳
 * 
 * @return	0				succ
 * 			else			fail
 */
int ForkWork(int forknum,bool bNeedCon)
{
	g_MapPids.clear();
	pid_t pid=0;
	int Ret;
	for(int i=0;i<forknum;++i)
	{
		pid=fork();
		if(pid==-1)
			return -1;//err
		else if(pid==0)//child
		{
			//ִ
		      	printf("i am child\n");
			g_MapPids.clear();
			Ret = DoYourWork(i);
			return Ret;
		}
		else
		{
		      	printf("i am farther,child is %d,index is %d\n",pid,i);
			g_MapPids.insert(pair<pid_t,int>((pid_t)pid,(int)i));
		}
	}
	printf("start all pids and start detect\n");
	DetectPids(bNeedCon);
	return 0;
}

/** 
 * @brief	ûҪִеĺҪûʵ֣
 * 
 * @param	iIndex		̷һuserId洢ڸ̵pid->userIdӳҪĿΪʵֵӽԼ̿¸mapuserId
 * 
 * @return	0			succ
 * 			else		fail
 */
int DoYourWork(int iIndex)
{
	//do your ownthing
	sleep(5);
	return 0;
}

int main(int argc,char ** argv)
{
	if(argc < 2)
	{
		printf("please input maxforknum needCon(0/1)\n");
		printf("eg. ./forkwork_use 10 1\n");
		return 0;
	}

	int iForkNum=atoi(argv[1]);
	bool bNeedCon=atoi(argv[2]);

	ForkWork(iForkNum,bNeedCon);
}
